c
code for ciffile
      subroutine ciffile
c--dummy routine to identify the module
      return
      end
c
code for cifblk
	block data cifblk
c--common block for cif file
c
      character*32 keyw,keyx,key1,key2,key3,key4,key5,key6,key7,key8
      common /cards/ keyw(8),keyx(2),key1(2),key2(10),
     1	key3(4),key4(3),key5(4),key6(15),key7(11),key8(16)
      common /ncards/ nkey,nkeyn(8)
      data nkey/8/,nkeyn/2,10,4,3,4,15,11,16/
      data keyx/
     1		'H atoms rigid to parent C atom' ,
     2		'Int. Tab. C, 4.2.6.8, 6.1.1.4'  /
      data keyw/
     1		'_chemical_formula_sum           ',
     2		'_cell_length_a                  ',
     3		'_symmetry_cell_setting          ',
     4		'_exptl_crystal_density_diffrn   ',
     5		'_diffrn_radiation_wavelength    ',
     6		'_diffrn_reflns_number           ',
     7		'_reflns_number_total            ',
     8		'_refine_ls_matrix_type          '/
      data key1/
     1		'_chemical_formula_sum           ',
     2		'_chemical_formula_weight        '/
      data key2/
     1		'_cell_length_a                  ',
     2		'_cell_length_b                  ',
     3		'_cell_length_c                  ',
     4		'_cell_angle_alpha               ',
     5		'_cell_angle_beta                ',
     6		'_cell_angle_gamma               ',
     7		'_cell_volume                    ',
     8		'_cell_formula_units_Z           ',
     9		'_cell_measurement_radiation     ',
     *		'_cell_measurement_wavelength    '/
      data key3/
     1		'_symmetry_cell_setting          ',
     2		'_symmetry_space_group_name_H-M  ',
     3		'_symmetry_Int_Tables_number     ',
     4		'_symmetry_equiv_pos_as_xyz      '/
      data key4/
     1		'_exptl_crystal_density_diffrn   ',
     2		'_exptl_crystal_F_000            ',
     3		'_exptl_absorpt_coefficient_mu   '/
      data key5/
     1		'_diffrn_radiation_wavelength    ',
     2		'_diffrn_radiation_type          ',
     3		'_diffrn_radiation_source        ',
     4		'_diffrn_radiation_monochromator '/
      data key6/
     1		'_diffrn_reflns_number           ',
     2		'_diffrn_reflns_theta_min        ',
     3		'_diffrn_reflns_theta_max        ',
     4		'_diffrn_reflns_limit_h_max      ',
     5		'_diffrn_reflns_limit_h_min      ',
     6		'_diffrn_reflns_limit_k_max      ',
     7		'_diffrn_reflns_limit_k_min      ',
     8		'_diffrn_reflns_limit_l_max      ',
     9		'_diffrn_reflns_limit_l_min      ',
     *		'_atom_type_symbol               ',
     1		'_atom_type_number_in_cell       ',
     2		'_atom_type_description          ',
     3		'_atom_type_scat_dispersion_real ',
     4		'_atom_type_scat_dispersion_imag ',
     5		'_atom_type_scat_source          '/
      data key7/
     1		'_reflns_number_total            ',
     2		'_reflns_number_observed         ',
     3		'_reflns_observed_criterion      ',
     4		'_reflns_limit_h_max             ',
     5		'_reflns_limit_h_min             ',
     6		'_reflns_limit_k_max             ',
     7		'_reflns_limit_k_min             ',
     8		'_reflns_limit_l_max             ',
     9		'_reflns_limit_l_min             ',
     *		'_reflns_d_resolution_high       ',
     1		'_reflns_d_resolution_low        '/
      data key8/
     1		'_refine_ls_matrix_type          ',
     2		'_refine_ls_hydrogen_treatment   ',
     3		'_refine_ls_weighting_scheme     ',
     4		'_refine_ls_number_reflns        ',
     5		'_refine_ls_number_parameters    ',
     6		'_refine_ls_R_factor_all         ',
     7		'_refine_ls_R_factor_obs         ',
     8		'_refine_ls_wR_factor_all        ',
     9		'_refine_ls_wR_factor_obs        ',
     *		'_refine_ls_goodness_of_fit_all  ',
     1		'_refine_ls_goodness_of_fit_obs  ',
     2		'_refine_ls_shift/esd_max        ',
     3		'_refine_ls_shift/esd_mean       ',
     4		'_refine_diff_density_max        ',
     5		'_refine_diff_density_min        ',
     6		'_refine_diff_density_rms        '/
      end
c
code for cifwrt
      subroutine cifwrt
c--this subroutine writes various experimental values to a file in
c  such a form as to be consistant with submission to acta. cryst..
c  such a file is commonly referred to as a cif file.
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c--
      character*60	ciffle,cfgfle,idfle,stfle
      common/cifle/ ciffle,cfgfle
      common /cdisu/ idfle,stfle
      common/ylimi/nfl,lfl,nlx
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common /xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common /worka/ a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common /workb/ ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     .             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      character*32 keyw,keyx,key1,key2,key3,key4,key5,key6,key7,key8
      common /cards/ keyw(8),keyx(2),key1(2),key2(10),
     1	key3(4),key4(3),key5(4),key6(15),key7(11),key8(16)
      common /ncards/ nkey,nkeyn(8)
      common /xtemp/ itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
c     character*80 nome
      character*12 ccls(7)
      character*64 follow
      character*32 key
      character*80 linea
      dimension inam3(8),nnn3(8),fmur(8),atwn(8),rvalue(11)
      dimension hl(12)
      character*1 obnum(0:9), chtmp, apice
      character*2 iwa(2)
      character*8 ifull(3)
      character *77 Pesi(18)
c--
      dimension nt(16)
      dimension ixyz(3),itras(24)
      dimension is(2,3),ts(3)
      dimension icent(2,2) ,icell(7)
      data icent(1,1)/2hno/,icent(2,1)/2hn-/
      data icent(1,2)/2h  /,icent(2,2)/2h  /
      data icell(1)/1hp/,icell(2)/1hi/,icell(3)/1hr/,icell(4)/1hf/
      data icell(5)/1ha/,icell(6)/1hb/,icell(7)/1hc/
      data ixyz/2hx ,2hy ,2hz /
      data itras/4h    ,4h0000,4h0000,4h1/8 ,
     2           4h1/6 ,4h0000,4h1/4 ,4h0000,
     3           4h1/3 ,4h3/8 ,4h0000,4h0000,
     4           4h1/2 ,4h0000,4h0000,4h5/8 ,
     5           4h2/3 ,4h0000,4h3/4 ,4h0000,
     6           4h5/6 ,4h7/8 ,4h0000,4h0000/
      data ccls /'   triclinic','  monoclinic','orthorhombic',
     .           '  tetragonal','rhombohedral','       cubic',
     .           '    trigonal'/
c--
      data obnum /'0','1','2','3','4','5','6','7','8','9'/
      data iwa /'Mo','Cu'/,ifull/'Diagonal','Full','Block'/
      Pesi(1) = 'W=Fo/P(1) if Fo >= P(1); W=1/W otherwise'
      Pesi(2) = 'W=1/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(3) = 'W=(Sin(Theta)/Lambda)^P(1)'
      Pesi(4) = 'W=(Lambda/Sin(Theta))^P(1)'
      Pesi(5) = 'W=1/(Sigma(Fo))^2'
      Pesi(6) = 'W=1.0'
      Pesi(7) = 'W=1/(1.+((Fo-P(2))/P(1))^2'
      Pesi(8) = 'W=1.0 if Fo<=P(1); W=P(1)/Fo if Fo>P(1)'
      Pesi(9) = 'W=Sigma(Fo)'
      Pesi(10)= 'W=1.0/Sigma(Fo)'
      Pesi(11)= 'W=(Sin(theta)/Lambda)^P(4)/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(12)= 'W=1/(P(1)*Sigma(Fo))^2+P(2)*Fo+P(3)*Fo^2)'
      Pesi(13)= 'W=1/(P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L))'
      Pesi(14)= 'W=1/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(15)= 'W=1/(P(1)+P(2)*(Sin(Th)/L)+P(3)*(Sin(Th)/L)^2)'
      Pesi(16)= 'W=1/(SUM(aj*Tj(F))j=1,n'
      Pesi(17)= 'W=(Sin(Th)/L)^P(3)/(P(1)*Sigma(Fo))^2+P(2)*Fo^2)'
      Pesi(18)= 'W=1/((P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L)'//
     1		'^P(5))*(Sigma(Fo))^2)'
c--		12345678901234567890123456789012345678901234567890
c
      apice=char(39)
c--read down the lists
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      l2p=nfl
      call xlat(hl)
      nfl=nfl+n2p*md2p
      l=n2p*3
      m2p=l2p
      do i=1,l
      store(m2p)=hl(i)
      m2p=m2p+1
      enddo
      nzeta=n2*n2p*(ic+1)
      call xfl03
      call xfl04
      call xfl05
      call xfl06
      l6a=l6d
      call sfl12
      jq=1
      if(jfr22(ix)) 9000,4030,4030
4030  continue
      call sfl22
c       call prt22
      if(jab22(ix)) 9000,8020,8020
8020  continue
      call sfl14
      call sfl18
c
c--open card keyword library
      nlen=80
      if(jopen(nccf,ciffle,nlen,ier)) 9000,210,210
210   continue
c
c--start loop on cif.dat
1000  continue
      read(nccf,'(a32,a)') key,follow
      if(key(1:6).eq.'######') goto 8100
c--	write(ncwu,'(a32,a)') key,follow
      do 8000 kkk=1,nkey
       if(key.eq.keyw(kkk)) then
	goto (2100,2200,2300,2400,2500,2600,2700,2800),kkk
c--_chemical_formula_sum
2100  continue
      ntt = 0
      fmu = 0.0
      f000 = 0.0
      atwt = 0.0
      natm=0
      m3 = l3
      do 500  j = 1,n3
       n = store(m3+12)/nzeta
       write(follow,'(a4)')istore(m3)
       chtmp=follow(1:1)
       call xupcase(chtmp)
       follow(1:1)=chtmp
       read(follow,'(a4)') inam3(j)
c--	inam3(j)=istore(m3)
       nnn3(j)=n
       nat = store(m3+13)
       atw = store(m3+14)
       fmur(j) = store(m3+16)
       f000 = f000 + nat*n*nzeta
       atwn(j) = atw*n
c---peso in atomi della cella ( m * z )
       atwt = atwt +atwn(j)
       ntt = ntt + n
       m3 = m3 + md3
 500   continue
      follow=' '
c	write(ncwu,'(8(a4,i4))')(inam3(j),nnn3(j),j=1,n3)
      write(follow,'(8(a4,i4))')(inam3(j),nnn3(j),j=1,n3)
      call skpblk(follow)
      write(ncpu,'(a32,5x,a)') key1(1),follow
      write(ncpu,'(a32,f15.2)') key1(2),atwt
      goto 1000
c--_cell_length_a
2200  continue
      l=l1p1+3
      do i=1,3
      store(l  )=store(l  )*rtd
      l=l+1
      enddo
      l=l1p1
      do i=1,7
      write(ncpu,'(a32,f15.3)') key2(i),store(l)
      l=l+1
      enddo
      nzeta=n2*n2p*(ic+1)
      write(ncpu,'(a32,i12)') key2(8),nzeta
      i=store(l3g+8)
      if(i.eq.1.or.i.eq.2)then
      write(ncpu,'(a32,5x,a)') key2(9), apice//iwa(i)//'K\a'//apice
      endif
      write(ncpu,'(a32,f15.5)') key2(10), store(l3g+10)
      goto 1000
c--_symmetry_cell_setting
2300  continue
      write(ncpu,'(a32,5x,a)') key3(1),ccls(isys)
      m2s=l2s
      do 1015 i=1,16
      nt(i)=istore(m2s)
      m2s=m2s+1
1015  continue
      follow=' '
      write(follow,'(16a1)')(nt(i),i=1,16)
	linea=apice//follow
      call shift(linea,lenp)
	linea(lenp+1:lenp+1)=apice
      write(ncpu,'(a32,5x,a)') key3(2),linea
      l102=nfl
      n102=ipuac(nt,store(l102),n)
      if(n102.gt.0) then
      write(ncpu,'(a32,i12)') key3(3),n102
      else
      write(ncpu,'(a32,5x,a)') key3(3),'?'
      end if
c--print the symmetry positions given
      write(ncpu,'(a)') 'loop_'
      write(ncpu,'(a32)') key3(4)
      m2=l2
      do 2080 ii=1,n2
c--write u. as. like t.i.
      do 2070 l=1,3
      do 2070 i=1,2
      is(i,l)=0
2070  continue
      m2f=m2+9
      m2i=m2
      do 2101 l=1,3
      m=1
      do 2090  i=1,3
      k=lint(m2i)
      m2i=m2i+1
      if(k.eq.0) go to 2090
      is(m,l)=k*i
      m=2
2090  continue
      ts(l)=store(m2f)
      m2f=m2f+1
2101  continue
      do 2110 i=1,40
      itemp(i)=ib
2110  continue
      l1=1
      do 2140 j3=1,3
      k=int(ts(j3)*24.0+0.0001)+1
      itemp(l1)=itras(k)
      l1=l1+1
      do 2130 j2=1,2
      m=iabs(is(j2,j3))
      if(m.eq.0) go to 2130
      itemp(l1)=iplus
      if(is(j2,j3).lt.0) itemp(l1)= inus
      l1=l1+1
      itemp(l1)=ixyz(m)
      l1=l1+1
2130  continue
      itemp(l1)=icc
      l1=l1+1
2140  continue
      itemp(l1-1)=ib
      linea=' '
      write(linea,2150)(itemp(i),i=1,20)
2150  format(20a4)
      call skpblk(linea)
      write(ncpu,'(a)') linea
      m2=m2+md2
2080  continue
      goto 1000
c--_exptl_crystal_density_diffrn
2400  continue
      dcal = atwt*nzeta/(store(l1p1+6)*0.602)
c---calcolo mu (cm-1)
      if(ntt.gt.0) then
      do j=1,n3
      fmu = fmu + (atwn(j)/atwt)*fmur(j)
      enddo
      end if
      fmu = fmu * dcal * 0.1
      write(ncpu,'(a32,f15.3)') key4(1),dcal
      n=f000
      write(ncpu,'(a32,i15)') key4(2),n
      write(ncpu,'(a32,f15.3)') key4(3),fmu
      goto 1000
c--_diffrn_radiation_wavelength
2500  continue
      i=store(l3g+8)
      write(ncpu,'(a32,f15.5)') key5(1), store(l3g+10)
      if(i.eq.1.or.i.eq.2)then
      write(ncpu,'(a32,5x,a)') key5(2), apice//iwa(i)//'K\a'//apice
      write(ncpu,'(a32,5x,a)') key5(3), apice//'X-ray tube'//apice
      write(ncpu,'(a32,5x,a)') key5(4), apice//'graphite'//apice
      else
      write(ncpu,'(a32,5x,a)') key5(2), ' ?'
      write(ncpu,'(a32,5x,a)') key5(3), ' ?'
      write(ncpu,'(a32,5x,a)') key5(4), ' ?'
      endif
      goto 1000
c--_diffrn_reflns_number
2600  continue
      write(ncpu,'(a32,5x,a)') key6(1), ' ?'
      if(store(l18+32).gt.0.0) then
      a= store(l18+32)/2.0
      write(ncpu,'(a32,f15.2)') key6(2), a
      a= store(l18+34)/2.0
      write(ncpu,'(a32,f15.2)') key6(3), a
      else
      write(ncpu,'(a32,5x,a)') key6(2), ' ?'
      write(ncpu,'(a32,5x,a)') key6(3), ' ?'
      end if
      m18=l18
      i=4
      do j=1,3
	n=store(m18+2)
	write(ncpu,'(a32,i15)') key6(i	), n
	n=store(m18  )
	write(ncpu,'(a32,i15)') key6(i+1), n
	i=i+2
	m18=m18+4
      enddo
      write(ncpu,'(a)') 'loop_'
      i=10
      do j=1,6
      write(ncpu,'(a32)') key6(i)
      i=i+1
      enddo
      m3 = l3
      do j = 1,n3
      n = store(m3+12)
      follow=keyx(2)
      call shift(follow,lenp)
      follow(lenp+1:lenp+1)=apice
      write(ncpu,2610)istore(m3),n,(istore(m3+17+l),l=1,3),
     1 store(m3+1),store(m3+11),follow
2610  format(1x,1h',a4,1h',i5,1x,1h',3a4,1h',2f8.4,3h ' ,a)
      m3=m3+md3
      enddo
      goto 1000
c--_reflns_number_total
2700  continue
      write(ncpu,'(a32,i15)') key7(1), n6
       nrif1=int(store(l6p+24))
       nrif2=int(store(l6p+25))
       nrif=n6-nrif1-nrif2
      write(ncpu,'(a32,i15)') key7(2), nrif
      obf=abs(store(l6p+23))
      if (obf.gt.0.0) then
      follow=apice//' F >'//obnum(int(obf))//'.'
     .	   //obnum(int(10.0*(obf-int(obf))))//' sigma(F) '//apice
      write(ncpu,'(a32,5x,a)') key7(3),follow
      else
      write(ncpu,'(a32,5x,a)') key7(3), apice//'none'//apice
      endif
      m18=l18
      i=4
      do j=1,3
      n=store(m18+2)
      write(ncpu,'(a32,i15)') key7(i  ), n
      n=store(m18  )
      write(ncpu,'(a32,i15)') key7(i+1), n
      i=i+2
      m18=m18+4
      enddo
      wave=store(l3g+10)
      if(store(l18+32).gt.0.0) then
      a= dtr*store(l18+34)/2.0
      resol=wave/(2.0*sin(a))
      write(ncpu,'(a32,f15.3)') key7(10), resol
      a= dtr*store(l18+32)/2.0
      resol=wave/(2.0*sin(a))
      write(ncpu,'(a32,f15.3)') key7(11), resol
      else
      write(ncpu,'(a32,5x,a)') key7(10), ' ?'
      write(ncpu,'(a32,5x,a)') key7(11), ' ?'
      end if
      goto 1000
c--_refine_ls_matrix_type
2800  continue
      m12=l12
      i=istore(m12)
      write(ncpu,'(a32,5x,a)') key8(1),ifull(i)
      follow=' ? '
      do j=1,n12
      i=istore(m12)
      if(i.eq.8) follow=keyx(1)
      m12=m12+md12
      enddo
      write(ncpu,'(a32,5x,a)') key8(2),follow
      linea=Pesi(iw4)
      call shift(linea,lenp)
      linea(lenp+1:lenp+1)=apice
      follow=apice//linea
      write(ncpu,'(a32,5x,a)') key8(3),follow
       nrif1=int(store(l6p+24))
       nrif2=int(store(l6p+25))
       nrif=n6-nrif1-nrif2
      write(ncpu,'(a32,i15)') key8(4), nrif
      write(ncpu,'(a32,i15)') key8(5), n22a
      rvalue(1)=store(l6p+35)/100.0
      rvalue(2)=store(l6p+38)/100.0
      rvalue(3)=store(l6p+42)/100.0
      rvalue(4)=store(l6p+45)/100.0
      rvalue(5)= store(l6p+49)
      rvalue(6)= store(l6p+52)
      rvalue(7)= store(l6p+56)
      rvalue(8)= store(l6p+57)
      rvalue(9)= store(l6p+58)
      rvalue(10)= store(l6p+59)
      rvalue(11)= store(l6p+60)
      j=6
      do i=1,11
      if(abs(rvalue(i)).gt.0.0) then
       write(ncpu,'(a32,f15.3)') key8(j),rvalue(i)
      else
       write(ncpu,'(a32,5x,a)') key8(j), ' ?'
      end if
       j=j+1
      enddo
      jcod=1
      call sdr5p(jcod)
      write(ncpu,'(a)') '  ',
     1'# GEOMETRY ###############################################'
      idev=1
      jcod=1
      call weox(idev,jcod)
      jcod=2
      call weox(idev,jcod)
      goto 1000
c--end of first if
      end if
8000  continue
      write(ncpu,'(a32,a)') key,follow
      goto 1000
8100  continue
      close(ncpu,status='keep')
      close(nccf,status='keep')
      return
c--error message
9000  continue
      call xwarni
      call xerr
      return
      end
c
code for skpblk
      subroutine skpblk(string)
c--strip away blank character(s)
      character string*(*)
      character*1 blank,apice
      character*60 string1
      data blank/' '/
c
      apice=char(39)
      k=len(string)
c
c-- TAB filter
c
      do 5 i=1,k
      j = ichar(string(i:i))
      if (j.eq.9) string(i:i)=blank
    5 continue
      ifin=1
      do 10 i=1,k
      if (string(i:i).ne.blank) then
                                  iniz=i
                                  go to 20
                                endif
   10 continue
      string=' '
      return
   20 do 30 i=k,1,-1
      if (string(i:i).ne.blank) then
                                  ifin=i
                                  go to 40
                                endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
      if (iniz.eq.1) goto 60
      do 50 i=1,lenp
      j=iniz+i-1
   50 string(i:i)=string(j:j)
   60 continue
      j=1
      string1=' '
      string1(1:1)=apice
      j=j+1
      do 70 i=1,lenp
      if(string(i:i).eq.blank) goto 70
      string1(j:j)=string(i:i)
      j=j+1
   70 continue
      string1(j:j)=apice
      string=string1
      return
      end
c
code for xinfo
      subroutine xinfo
c--this subroutine writes various experimental values
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst04/iw4,l4,m4,n4
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst06/l6,l6a,l6d,ld6p,m6,m6dk,n6dk,md6d,n6d,n6,n6p,
     2 l6rs,l6rk,l6in,l6f,l6e,l6p,n6f,n6dd,kk1,kk2,kk3,sys06
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c--
      character*60	ciffle,cfgfle,idfle,stfle
      common/cifle/ ciffle,cfgfle
      common /cdisu/ idfle,stfle
      common/ylimi/nfl,lfl,nlx
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common /xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common /worka/ a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common /workb/ ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     .             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      character*32 keyw,keyx,key1,key2,key3,key4,key5,key6,key7,key8
      common /cards/ keyw(8),keyx(2),key1(2),key2(10),
     1	key3(4),key4(3),key5(4),key6(15),key7(11),key8(16)
      common /ncards/ nkey,nkeyn(8)
      common /xtemp/ itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
c     character*80 nome
      character*12 ccls(7)
      character*48 follow
      character*32 key
      character*80 linea
      dimension inam3(8),nnn3(8),fmur(8),atwn(8),rvalue(11)
      dimension hl(12)
      character*1 obnum(0:9), chtmp, apice
      character*2 iwa(2)
      character*8 ifull(3)
      character *70 Pesi(18)
c--
      character *6 cell(7)
      character*11 lhkl(6)
      character*19 lsl(11)
      dimension nt(16)
      dimension ixyz(3),itras(24)
      dimension is(2,3),ts(3)
      dimension icent(2,2) ,icell(7)
      data icent(1,1)/2hno/,icent(2,1)/2hn-/
      data icent(1,2)/2h  /,icent(2,2)/2h  /
      data icell(1)/1hp/,icell(2)/1hi/,icell(3)/1hr/,icell(4)/1hf/
      data icell(5)/1ha/,icell(6)/1hb/,icell(7)/1hc/
      data ixyz/2hx ,2hy ,2hz /
      data itras/4h    ,4h0000,4h0000,4h1/8 ,
     2           4h1/6 ,4h0000,4h1/4 ,4h0000,
     3           4h1/3 ,4h3/8 ,4h0000,4h0000,
     4           4h1/2 ,4h0000,4h0000,4h5/8 ,
     5           4h2/3 ,4h0000,4h3/4 ,4h0000,
     6           4h5/6 ,4h7/8 ,4h0000,4h0000/
      data ccls /'   triclinic','  monoclinic','orthorhombic',
     .           '  tetragonal','rhombohedral','       cubic',
     .		 '    trigonal'/
      data cell /'a','b','c','alpha','beta','gamma','volume'/
c--
      data obnum /'0','1','2','3','4','5','6','7','8','9'/
      data iwa /'Mo','Cu'/,ifull/'Diagonal','Full','Block'/
      data lhkl/'limit_h_max',
     2		'limit_h_min',
     3		'limit_k_max',
     4		'limit_k_min',
     5		'limit_l_max',
     6		'limit_l_min'/
      data lsl /'R_factor_all       ',
     2          'R_factor_obs       ',
     3          'wR_factor_all      ',
     4          'wR_factor_obs      ',
     5          'goodness_of_fit_all',
     6          'goodness_of_fit_obs',
     7          'shift/esd_max      ',
     8          'shift/esd_mean     ',
     9          'density_max        ',
     *          'density_min        ',
     1          'density_rms        '/


      Pesi(1) = 'W=Fo/P(1) if Fo >= P(1); W=1/W otherwise'
      Pesi(2) = 'W=1/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(3) = 'W=(Sin(Theta)/Lambda)^P(1)'
      Pesi(4) = 'W=(Lambda/Sin(Theta))^P(1)'
      Pesi(5) = 'W=1/(Sigma(Fo))^2'
      Pesi(6) = 'W=1.0'
      Pesi(7) = 'W=1/(1.+((Fo-P(2))/P(1))^2'
      Pesi(8) = 'W=1.0 if Fo<=P(1); W=P(1)/Fo if Fo>P(1)'
      Pesi(9) = 'W=Sigma(Fo)'
      Pesi(10)= 'W=1.0/Sigma(Fo)'
      Pesi(11)= 'W=(Sin(theta)/Lambda)^P(4)/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(12)= 'W=1/(P(1)*Sigma(Fo))^2+P(2)*Fo+P(3)*Fo^2)'
      Pesi(13)= 'W=1/(P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L))'
      Pesi(14)= 'W=1/(P(1)+P(2)*Fo+P(3)*Fo^2)'
      Pesi(15)= 'W=1/(P(1)+P(2)*(Sin(Th)/L)+P(3)*(Sin(Th)/L)^2)'
      Pesi(16)= 'W=1/(SUM(aj*Tj(F))j=1,n'
      Pesi(17)= 'W=(Sin(Th)/L)^P(1)/(Sigma(Fo))^2+P(2)*Fo^2)'
      Pesi(18)= 'W=1/((P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L))'//
     1		'*(Sigma(Fo))^2)'
c
      call xcsae
      call xrsl
c--check if a list 14 exists
      call srlin(14,li,lj,lk,ll,lm)
      if(lj) 1110,1110,1120
1110  continue
      ix=0
      call sc014(ix)
1120  continue
      call srlin(18,li,lj,lk,ll,lm)
      if(lj) 930,930,920
  930 continue
      call xfl01
      call xfl02
      call set18
  920 continue
c
c--read down the lists
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      l2p=nfl
      call xlat(hl)
      nfl=nfl+n2p*md2p
      l=n2p*3
      m2p=l2p
      do i=1,l
      store(m2p)=hl(i)
      m2p=m2p+1
      enddo
      nzeta=n2*n2p*(ic+1)
      call xfl03
c--check if a list 4 exists
      call srlin(4,li,lj,lk,ll,lm)
      if(lj) 1111,1111,1121
1111  continue
      ix=2
      np=0
      call sc04(ix,np)
1121  continue
      call xfl04
      ilist5=0
      call srlin(5,li,lj,lk,ll,lm)
      if(lj) 1131,1131,1141
1131  continue
      ilist5=-1
1141  continue
      if(ilist5.eq.0) call xfl05
      call xfl06
      l6a=l6d
      if(ilist5.eq.0) then
c--check if a list 12 exists
      call srlin(12,li,lj,lk,ll,lm)
      if(lj) 1112,1112,1122
1112  continue
       ix=1
       inext=0
       if(icrea12(ix,inext,ladr,nsched))9000,1122,1122
1122  continue
      call sfl12
      jq=1
      if(jfr22(ix)) 9000,1130,1130
1130  continue
      call sfl22
c       call prt22
      if(jab22(ix)) 9000,1150,1150
1150  continue
      endif
      call sfl14
      call sfl18
c
c--start loop on the list
      nkey=8
      do 8000 kkk=1,nkey
      goto (2100,2200,2300,2400,2500,2600,2700,2800),kkk
c--_chemical_formula_sum
2100  continue
      ntt = 0
      fmu = 0.0
      f000 = 0.0
      atwt = 0.0
      natm=0
      m3 = l3
      do 500  j = 1,n3
       n = store(m3+12)/nzeta
       write(follow,'(a2)')istore(m3)
       chtmp=follow(1:1)
       call xupcase(chtmp)
       follow(1:1)=chtmp
       read(follow,'(a2)') inam3(j)
c--	inam3(j)=istore(m3)
       nnn3(j)=n
       nat = store(m3+13)
       atw = store(m3+14)
       fmur(j) = store(m3+16)
       f000 = f000 + nat*n*nzeta
       atwn(j) = atw*n
c---peso in atomi della cella ( m * z )
       atwt = atwt +atwn(j)
       ntt = ntt + n
       m3 = m3 + md3
 500   continue
      follow=' '
c	write(ncwu,'(8(a2,i4))')(inam3(j),nnn3(j),j=1,n3)
      write(follow,'(8(a2,i4))')(inam3(j),nnn3(j),j=1,n3)
      call skpblk(follow)
      write(ncwu,2110) follow
2110  format(' chemical_formula_sum    : ',a )
      write(ncwu,2120) atwt
2120  format(' chemical_formula_weight : ',f10.2)
      goto 8000
c--_cell_length_a
2200  continue
      l=l1p1+3
      do i=1,3
      store(l  )=store(l  )*rtd
      l=l+1
      enddo
      l=l1p1
      do i=1,7
      write(ncwu,2210) cell(i),store(l)
2210  format(' cell_length_',a,' : ',f15.3)
      l=l+1
      enddo
      nzeta=n2*n2p*(ic+1)
      write(ncwu,2220) nzeta
2220  format(' cell_formula_units_Z : ',i13)
      goto 8000
c--_symmetry_cell_setting
2300  continue
      write(ncwu,2310) ccls(isys)
2310  format(' cell_setting       : ',a)
      m2s=l2s
      do 1015 i=1,16
      nt(i)=istore(m2s)
      m2s=m2s+1
1015  continue
      follow=' '
      write(follow,'(16a1)')(nt(i),i=1,16)
      write(ncwu,2320) follow
2320  format(' space_group        : ',a)
      l102=nfl
      n102=ipuac(nt,store(l102),n)
      if(n102.gt.0) then
      write(ncwu,2330) n102
2330  format(' Int_Tables_number  : ',i10)
      end if
c--print the symmetry positions given
      write(ncwu,2340) n2
2340  format(' No of equiv_pos    : ',i10)
      m2=l2
      do 2080 ii=1,n2
c--write u. as. like t.i.
      do 2070 l=1,3
      do 2070 i=1,2
      is(i,l)=0
2070  continue
      m2f=m2+9
      m2i=m2
      do 2101 l=1,3
      m=1
      do 2090  i=1,3
      k=lint(m2i)
      m2i=m2i+1
      if(k.eq.0) go to 2090
      is(m,l)=k*i
      m=2
2090  continue
      ts(l)=store(m2f)
      m2f=m2f+1
2101  continue
      do 2102 i=1,40
      itemp(i)=ib
2102  continue
      l1=1
      do 2140 j3=1,3
      k=int(ts(j3)*24.0+0.0001)+1
      itemp(l1)=itras(k)
      l1=l1+1
      do 2130 j2=1,2
      m=iabs(is(j2,j3))
      if(m.eq.0) go to 2130
      itemp(l1)=iplus
      if(is(j2,j3).lt.0) itemp(l1)= inus
      l1=l1+1
      itemp(l1)=ixyz(m)
      l1=l1+1
2130  continue
      itemp(l1)=icc
      l1=l1+1
2140  continue
      itemp(l1-1)=ib
      linea=' '
      write(linea,2150)(itemp(i),i=1,20)
2150  format(20a4)
      call skpblk(linea)
      write(ncwu,'(a)') linea
      m2=m2+md2
2080  continue
      goto 8000
c--_exptl_crystal_density_diffrn
2400  continue
      dcal = atwt*nzeta/(store(l1p1+6)*0.602)
c---calcolo mu (cm-1)
      if(ntt.gt.0) then
      do j=1,n3
      fmu = fmu + (atwn(j)/atwt)*fmur(j)
      enddo
      end if
      fmu = fmu * dcal * 0.1
      write(ncwu,2410) dcal
2410  format(' Crystal_density    : ',f10.3)
      n=f000
      write(ncwu,2420) n
2420  format(' F_000              : ',i10)
      write(ncwu,2430) fmu
2430  format(' absorpt_coefficient_mu : ',f8.3)
      write(ncwu,2630)
2630  format(' symbol, number_in_cell, description, dispersion_real',
     1	', dispersion_imag')
      m3 = l3
      do j = 1,n3
      n = store(m3+12)
      write(ncwu,2640)istore(m3),n,(istore(m3+17+l),l=1,3),
     1 store(m3+1),store(m3+11)
2640  format(3x,a2,6x,i5,10x,3a4,2f12.4)
      m3=m3+md3
      enddo
      goto 8000
c--_diffrn_radiation_wavelength
2500  continue
      i=store(l3g+8)
      write(ncwu,2510) store(l3g+10)
2510  format(' Radiation_wavelength   : ',f8.5)
      if(i.eq.1.or.i.eq.2)then
      write(ncwu,2520) iwa(i)//'K\a'
2520  format(' Radiation_type         : ',a)
      endif
      goto 8000
c--_diffrn_reflns_number
2600  continue
      if(store(l18+32).gt.0.0) then
      a= store(l18+32)/2.0
      write(ncwu,2610) a
2610  format(' Theta_min              : ',f8.2)
      a= store(l18+34)/2.0
      write(ncwu,2620) a
2620  format(' Theta_max              : ',f8.2)
      end if
      m18=l18
      i=1
      do j=1,3
      n=store(m18+2)
      write(ncwu,'(a,i15)') lhkl(i  ), n
      n=store(m18  )
      write(ncwu,'(a,i15)') lhkl(i+1), n
      i=i+2
      m18=m18+4
      enddo
      wave=store(l3g+10)
      if(store(l18+32).gt.0.0) then
      a= dtr*store(l18+34)/2.0
      resol=wave/(2.0*sin(a))
      write(ncwu,2740) resol
2740  format(' d_resolution_high : ',f15.3)
      a= dtr*store(l18+32)/2.0
      resol=wave/(2.0*sin(a))
      write(ncwu,2750)	resol
2750  format(' d_resolution_low  : ',f15.3)
      end if
      goto 8000
c--_reflns_number_total
2700  continue
      write(ncwu,2710) n6
2710  format(' Reflns_number_total    : ',i15)
       nrif1=int(store(l6p+24))
       nrif2=int(store(l6p+25))
       nrif=n6-nrif1-nrif2
      write(ncwu,2720) nrif
2720  format(' Reflns_number_observed : ',i15)
      obf=abs(store(l6p+23))
      if (obf.gt.0.0) then
      follow=' F >'//obnum(int(obf))//'.'
     .	   //obnum(int(10.0*(obf-int(obf))))//' sigma(F) '
      write(ncwu,2730) follow
2730  format(' Observed_criterion     : ',a)
      endif
      goto 8000
c--_refine_ls_matrix_type
2800  continue
      m12=l12
      i=istore(m12)
      write(ncwu,2810) ifull(i)
2810  format(' Matrix_type            : ',a)
      follow=' ? '
      do j=1,n12
      i=istore(m12)
      if(i.eq.8) follow=keyx(1)
      m12=m12+md12
      enddo
      if(follow.ne.' ? ') then
      write(ncwu,2820) follow
2820  format(' Hydrogen_treatment     : ',a)
      endif
      follow=Pesi(iw4)
      write(ncwu,2830) follow
2830  format(' Weighting_scheme       : ',a)
      write(ncwu,2835) n22a
2835  format(' Number_parameters      : ',i15)
      rvalue(1)=store(l6p+35)/100.0
      rvalue(2)=store(l6p+38)/100.0
      rvalue(3)=store(l6p+42)/100.0
      rvalue(4)=store(l6p+45)/100.0
      rvalue(5)= store(l6p+49)
      rvalue(6)= store(l6p+52)
      rvalue(7)= store(l6p+56)
      rvalue(8)= store(l6p+57)
      rvalue(9)= store(l6p+58)
      rvalue(10)= store(l6p+59)
      rvalue(11)= store(l6p+60)
      do i=1,11
      if(abs(rvalue(i)).gt.0.0) then
       write(ncwu,'(1x,a,f15.3)') lsl(i),rvalue(i)
      else
       write(ncwu,'(1x,a,5x,a)')  lsl(i), ' ?'
      end if
      enddo
8000  continue
      return
c--error message
9000  continue
      call xwarni
      call xerr
      return
      end
